cmake_minimum_required(VERSION 3.0)

if ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
    set(ARCH "arm64")
elseif ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "AMD64|x86_64")
    if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
        set(ARCH "x86")
    elseif ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
        set(ARCH "x64")
    endif ()
else ()
    message(FATAL_ERROR "Unable to determine CPU architecture")
endif ()

set(ELECTRON_PACKAGE_DIR "${CMAKE_CURRENT_LIST_DIR}" PARENT_SCOPE)
set(ELECTRON_PACKAGE_DIR "${CMAKE_CURRENT_LIST_DIR}")
if (UNIX)
    set(ELECTRON_PLATFORM_DIR "${ELECTRON_PACKAGE_DIR}/linux/gcc6_3_0/${ARCH}" PARENT_SCOPE)
    set(ELECTRON_PLATFORM_DIR "${ELECTRON_PACKAGE_DIR}/linux/gcc6_3_0/${ARCH}")
elseif (WIN32)
    set(ELECTRON_PLATFORM_DIR "${ELECTRON_PACKAGE_DIR}/windows/vc142/${ARCH}" PARENT_SCOPE)
    set(ELECTRON_PLATFORM_DIR "${ELECTRON_PACKAGE_DIR}/windows/vc142/${ARCH}")
endif ()

function(add_imported_lib_static ELECTRON_PLATFORM_DIR LIB STATICLIB)
    message(STATUS "Adding library '${LIB}'. Reference the library using the TARGET '${LIB}'")
    add_library("${LIB}" SHARED IMPORTED GLOBAL)
    set_property(TARGET "${LIB}" APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${ELECTRON_PACKAGE_DIR}/include")
    set_property(TARGET "${LIB}" APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${ELECTRON_PACKAGE_DIR}/include/node")
    set_property(TARGET "${LIB}" APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${ELECTRON_PACKAGE_DIR}/include/node/libplatform")

    set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION "${ELECTRON_PLATFORM_DIR}/release/${CMAKE_SHARED_LIBRARY_PREFIX}${LIB}${CMAKE_SHARED_LIBRARY_SUFFIX}")

    # static lib for windows
    if (WIN32)
        set_target_properties("${LIB}" PROPERTIES IMPORTED_IMPLIB "${ELECTRON_PLATFORM_DIR}/release/${CMAKE_STATIC_LIBRARY_PREFIX}${STATICLIB}${CMAKE_STATIC_LIBRARY_SUFFIX}")
    endif ()
endfunction(add_imported_lib_static)

add_imported_lib_static("${ELECTRON_PLATFORM_DIR}" "node" "node")
